from .test_setup import *
import pytest


def _test(res, exp):

    if isinstance(exp, pd.DataFrame):
        eq, msg = dios_eq_df(res, exp, with_msg=True)
        assert eq, msg

    else:
        assert type(exp) == type(res)

        if isinstance(exp, pd.Series):
            eq, msg = diosSeries_eq_dfSeries(res, exp, with_msg=True)
            assert eq, msg

        # scalars
        else:
            assert res == exp


@pytest.mark.parametrize('idxer', BASIC_INDEXER)
def test_dflike__get__(df_, dios_, idxer):
    print(idxer)
    exp = df_[idxer]
    res = dios_[idxer]
    _test(res, exp)


@pytest.mark.parametrize('locR', R_LOC_INDEXER)
@pytest.mark.parametrize('locC', C_LOC_INDEXER)
def test_dflike__get_loc__(df_, dios_, locR, locC):
    print(locR)
    print(locC)
    exp = df_.loc[locR, locC]
    res = dios_.loc[locR, locC]
    _test(res, exp)


@pytest.mark.parametrize('ilocR', R_iLOC_INDEXER)
@pytest.mark.parametrize('ilocC', C_iLOC_INDEXER)
def test_dflike__get_iloc__(df_, dios_, ilocR, ilocC):
    print(ilocR)
    print(ilocC)
    exp = df_.iloc[ilocR, ilocC]
    res = dios_.iloc[ilocR, ilocC]
    _test(res, exp)


VALS = [99, ]

@pytest.mark.parametrize('idxer', BASIC_INDEXER)
@pytest.mark.parametrize('val', VALS)
def test_dflike__set__(df_, dios_, idxer, val):
    print(idxer)
    exp = df_
    res = dios_
    exp[idxer] = val
    res[idxer] = val
    _test(res, exp)


@pytest.mark.parametrize('locR', R_LOC_INDEXER)
@pytest.mark.parametrize('locC', C_LOC_INDEXER)
@pytest.mark.parametrize('val', VALS)
def test_dflike__set_loc__(df_, dios_, locR, locC, val):
    print(locR)
    print(locC)
    exp = df_
    res = dios_
    exp.loc[locR, locC] = val
    res.loc[locR, locC] = val
    _test(res, exp)


@pytest.mark.parametrize('ilocR', R_iLOC_INDEXER)
@pytest.mark.parametrize('ilocC', C_iLOC_INDEXER)
@pytest.mark.parametrize('val', VALS)
def test_dflike__set_iloc__(df_, dios_, ilocR, ilocC, val):
    print(ilocR)
    print(ilocC)
    exp = df_
    res = dios_
    exp.iloc[ilocR, ilocC] = val
    res.iloc[ilocR, ilocC] = val
    _test(res, exp)

